/**************************************************************************
*   Copyright (C) 2009 by Silicium628 (France)                            *
*   http://silicium628.chez-alice.fr/                                     *
*   http://www.silicium628.fr/                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation;                                         *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY;                                             *
*   See the GNU General Public License for more details.                  *
***************************************************************************/

#include "cube.h"
#include <math.h>
#include "vecteur3d.h"

// #include <QDebug>

// #include "complexe.cpp"

QPen penI(QColor::fromRgb(255, 0, 0, 255), 1, Qt::SolidLine);
QPen penJ(QColor::fromRgb(0, 200, 0, 255), 1, Qt::SolidLine);
QPen penK(QColor::fromRgb(0, 0, 255, 255), 1, Qt::SolidLine);

int offsetX = 500; // pour le tracé à l'écran
int offsetY = 500;

Cube::Cube()
{
   h=2.0;
}

double Cube::getTaille()
{ return h; }


void Cube::setTaille(double h_i)
{
    h = h_i;
  //  set_sommets();
}


void Cube::setPosition(Vecteur3D position_i)
{
    position = position_i;
}



void Cube::RotX(double angle_i)
{
   // set_sommets();
    A.RotX(angle_i);
    B.RotX(angle_i);
    C.RotX(angle_i);
    D.RotX(angle_i);
    E.RotX(angle_i);
    F.RotX(angle_i);
    G.RotX(angle_i);
    H.RotX(angle_i);
    I.RotX(angle_i);
    J.RotX(angle_i);
    K.RotX(angle_i);

    V1.RotX(angle_i);
    V2.RotX(angle_i);
    V3.RotX(angle_i);
}


void Cube::RotY(double angle_i)
{
    A.RotY(angle_i);
    B.RotY(angle_i);
    C.RotY(angle_i);
    D.RotY(angle_i);
    E.RotY(angle_i);
    F.RotY(angle_i);
    G.RotY(angle_i);
    H.RotY(angle_i);
    I.RotY(angle_i);
    J.RotY(angle_i);
    K.RotY(angle_i);

    V1.RotY(angle_i);
    V2.RotY(angle_i);
    V3.RotY(angle_i);
}


void Cube::RotZ(double angle_i)
{
    A.RotZ(angle_i);
    B.RotZ(angle_i);
    C.RotZ(angle_i);
    D.RotZ(angle_i);
    E.RotZ(angle_i);
    F.RotZ(angle_i);
    G.RotZ(angle_i);
    H.RotZ(angle_i);
    I.RotZ(angle_i);
    J.RotZ(angle_i);
    K.RotZ(angle_i);

    V1.RotZ(angle_i);
    V2.RotZ(angle_i);
    V3.RotZ(angle_i);
}


void Cube::set_sommets()
{
    Centre.setX(0); Centre.setY(0); Centre.setZ(0);

//FACE AVANT
    A.setX(-h); A.setY(-h); A.setZ(-h);
    B.setX(h); B.setY(-h); B.setZ(-h);
    C.setX(h); C.setY(h); C.setZ(-h);
    D.setX(-h); D.setY(h); D.setZ(-h);

//FACE ARRIERE
    E.setX(-h); E.setY(-h); E.setZ(h);
    F.setX(h); F.setY(-h); F.setZ(h);
    G.setX(h); G.setY(h); G.setZ(h);
    H.setX(-h); H.setY(h); H.setZ(h);

//AXES
    I.setX(2*h); I.setY(0);    I.setZ(0);
    J.setX(0);   J.setY(2*h);  J.setZ(0);
    K.setX(0);   K.setY(0);    K.setZ(2*h);
}


void Cube::set_V1(Vecteur3D Vi)
{
    V1=Vi;
}


void Cube::set_V2(Vecteur3D Vi)
{
    V2=Vi;
}


void Cube::set_V3(Vecteur3D Vi)
{
    V3=Vi;
}


void Cube::projection(Vecteur3D V1, Vecteur3D V2, QGraphicsItemGroup *groupe_i, QPen pen_i)
{
    double x1,y1,x2,y2;
    double d1=40; // distance de l'oeil à (en arrière de) l'écran de projection

    x1=50*(V1.getX()+position.getX())*d1 / (d1+V1.getZ()+position.getZ());
    y1=50*(V1.getY()+position.getY())*d1 / (d1+V1.getZ()+position.getZ());

    x2=50*(V2.getX()+position.getX())*d1 / (d1+V2.getZ()+position.getZ());
    y2=50*(V2.getY()+position.getY())*d1 / (d1+V2.getZ()+position.getZ());
    ligne_i = new QGraphicsLineItem(offsetX+x1, offsetY+y1, offsetX+x2, offsetY+y2);
    ligne_i->setPen(pen_i);
    groupe_i->addToGroup(ligne_i);
}




void Cube::tracer(QGraphicsItemGroup *groupe_i, QPen pen_i, int axes)
{
   double x1,y1,x2,y2;

    //TRACE LES 12 ARETES
    projection(A, B, groupe_i, pen_i); //segment AB
    projection(B, C, groupe_i, pen_i);
    projection(C, D, groupe_i, pen_i);
    projection(D, A, groupe_i, pen_i);
    projection(E, F, groupe_i, pen_i);
    projection(F, G, groupe_i, pen_i);
    projection(G, H, groupe_i, pen_i);
    projection(H, E, groupe_i, pen_i);
    projection(A, E, groupe_i, pen_i);
    projection(B, F, groupe_i, pen_i);
    projection(C, G, groupe_i, pen_i);
    projection(D, H, groupe_i, pen_i);

    if (axes == 1)
    {
//axe I
        x1=0; y1=0;
        x2=50*I.getX(); y2=50*I.getY();
        ligne_i = new QGraphicsLineItem(offsetX-300+x1, offsetY+300+y1, offsetX-300+x2, offsetY+300+y2);
        ligne_i->setPen(penI);
        groupe_i->addToGroup(ligne_i);
//axe J
        x1=0; y1=0;
        x2=50*J.getX(); y2=50*J.getY();
        ligne_i = new QGraphicsLineItem(offsetX-300+x1, offsetY+300+y1, offsetX-300+x2, offsetY+300+y2);
        ligne_i->setPen(penJ);
        groupe_i->addToGroup(ligne_i);
//axe K
        x1=0; y1=0;
        x2=50*K.getX(); y2=50*K.getY();
        ligne_i = new QGraphicsLineItem(offsetX-300+x1, offsetY+300+y1, offsetX-300+x2, offsetY+300+y2);
        ligne_i->setPen(penK);
        groupe_i->addToGroup(ligne_i);
    }
}


void Cube::tracer_vecteur1(QGraphicsItemGroup *groupe_i, QPen pen_i)
{
    projection(Centre, V1, groupe_i, pen_i);
}


void Cube::tracer_vecteur2(QGraphicsItemGroup *groupe_i, QPen pen_i)
{
    projection(Centre, V2, groupe_i, pen_i);
}


void Cube::tracer_vecteur3(QGraphicsItemGroup *groupe_i, QPen pen_i)
{
    projection(Centre, V3, groupe_i, pen_i);
}

