 /**************************************************************************
 *   Copyright (C) 2009 by Silicium628 (France)                            *
 *   http://silicium628.chez-alice.fr/                                     *
 *   http://www.silicium628.fr/                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation;                                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY;                                             *
 *   See the GNU General Public License for more details.                  *
 ***************************************************************************/

#ifndef CUBE_H
#define CUBE_H

#include "vecteur3d.h"
#include <QGraphicsLineItem>
#include <QGraphicsItemGroup>

class Cube  
{
// private par defaut

// on definit le cube par ses 6 sommets a,b,c,d,e,f,g,h (extrémités de 6 vecteurs 3D)
// le cube a pour centre l'origine du repère
// pour faire tourner le cube, il suffit de faire tourner ces vecteurs
    Vecteur3D A, B, C, D, E, F, G, H; // huits sommets
    Vecteur3D I,J,K; // trois axes pouvant êtres tracés
    Vecteur3D V1, V2, V3; // des vecteurs tracés à l'intérieur du cube (pour représenter les opérations sur les vecteurs)
    Vecteur3D Centre;

    double h; // longueur des aretes
    Vecteur3D position;
	double alpha; 
	double beta;
	double gamma;

 public:

    Cube(); // Constructeur

    double getTaille();

    void setTaille(double h_i);
    void setPosition(Vecteur3D position_i);
//orientation

    void set_sommets();
    void set_V1(Vecteur3D Vi);
    void set_V2(Vecteur3D Vi);
    void set_V3(Vecteur3D Vi);

    void RotX(double angle_i);
    void RotY(double angle_i);
    void RotZ(double angle_i);

    void projection(Vecteur3D V1, Vecteur3D V2, QGraphicsItemGroup *groupe_i, QPen pen_i);
    void tracer(QGraphicsItemGroup *groupe_i, QPen pen_i, int axes);
    void tracer_vecteur1(QGraphicsItemGroup *groupe_i, QPen pen_i);
    void tracer_vecteur2(QGraphicsItemGroup *groupe_i, QPen pen_i);
    void tracer_vecteur3(QGraphicsItemGroup *groupe_i, QPen pen_i);

private:

    QGraphicsLineItem *ligne_i;

};
#endif
