/*
  Programme écrit par Silicium628
  ce logiciel est libre et open source

  */
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "vecteur3d.cpp"
#include "cube.cpp"
#include <QTimer>

// #include <QDebug>

QString version = "3.1";

QColor couleur_ecran = QColor::fromRgb(255, 255, 255, 255);
QColor couleur_ligne = QColor::fromRgb(0, 0, 0, 255);
QColor couleur_trace1 = QColor::fromRgb(255, 0, 0, 255);
QColor couleur_trace2 = QColor::fromRgb(0, 255, 0, 255);
QColor couleur_trace3 = QColor::fromRgb(0, 0, 255, 255);
QColor couleur_vecteur1 = QColor::fromRgb(255, 0, 0, 255);
QColor couleur_vecteur2 = QColor::fromRgb(0, 255, 0, 255);
QColor couleur_vecteur3 = QColor::fromRgb(255, 255, 0, 255);
QColor couleur_texte = QColor::fromRgb(255, 255, 0, 255);

QPen pen_ligne(couleur_ligne, 1, Qt::SolidLine);
QPen pen_trace1(couleur_trace1, 1, Qt::SolidLine);
QPen pen_trace2(couleur_trace2, 1, Qt::SolidLine);
QPen pen_trace3(couleur_trace3, 1, Qt::SolidLine);
QPen pen_vecteur1(couleur_vecteur1, 1, Qt::SolidLine);
QPen pen_vecteur2(couleur_vecteur2, 1, Qt::SolidLine);
QPen pen_vecteur3(couleur_vecteur3, 1, Qt::SolidLine);
QPen pen_cadre(couleur_ligne, 1, Qt::SolidLine);

int init = 0;

Cube cube1;
Cube cube2;
Vecteur3D V1, V2, V3;

double alpha0 =0;
double beta0 =0;
double gamma0 =0;


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)
{

    setupUi(this);
    this->setFixedSize(1220, 960);
    setWindowTitle("Dessin Vecteurs3D - v" + version);

    scene = new QGraphicsScene(this);
    scene->setBackgroundBrush(couleur_ecran);
    graphicsView1->setScene(scene);
    graphicsView1->setGeometry(5,5,905,905); // POSITION et dimensions de l'écran

    groupe_axes = new QGraphicsItemGroup();
    scene->addItem(groupe_axes);
    groupe_cube = new QGraphicsItemGroup();
    scene->addItem(groupe_cube);
    groupe_vecteurs = new QGraphicsItemGroup();
    scene->addItem(groupe_vecteurs);

    Timer1 = new QTimer(this);
    connect(Timer1, SIGNAL(timeout()), this, SLOT(Timer1_clic()));

    tracer_cadre();

    cube1.setTaille(2.0); // longueur des aretes
    cube2.setTaille(2.0); // longueur des aretes

    Vecteur3D pos1;
    pos1.setX(-4.0);
    pos1.setY(0);
    pos1.setZ(0);
    cube1.setPosition(pos1);

//    cube1.tracer(groupe_cube, pen_ligne, 1);

    Vecteur3D pos2;
    pos2.setX(4.0);
    pos2.setY(0);
    pos2.setZ(0);
    cube2.setPosition(pos2);

    pen_vecteur1.setWidth(2);
    pen_vecteur2.setWidth(2);
    pen_vecteur3.setWidth(2);

// valeur des vecteurs
    spinBox_1->setValue(1);
    spinBox_2->setValue(0);
    spinBox_3->setValue(0);

    spinBox_7->setValue(0);
    spinBox_8->setValue(1);
    spinBox_9->setValue(0);

    V1.setX(spinBox_1->value());
    V1.setY(spinBox_2->value());
    V1.setZ(spinBox_3->value());

    V2.setX(spinBox_7->value());
    V2.setY(spinBox_8->value());
    V2.setZ(spinBox_9->value());

 //   V3=V1*V2;

    cube1.set_V1(V1);
    cube1.set_V2(V2);
    cube1.set_V3(V3);

    cube2.set_V1(V1);
    cube2.set_V2(V2);
    cube2.set_V3(V3);

    init=1;
    tracer("abg");

    Timer1->start(50);

 //   horizontalSlider1->setValue(30);
 //   horizontalSlider2->setValue(32);
 //   horizontalSlider3->setValue(13);

//    cube2.tracer(groupe_cube, pen_ligne, 1);

//    cube1.tracer_vecteur1(groupe_vecteurs, pen_vecteur1);
//    cube1.tracer_vecteur2(groupe_vecteurs, pen_vecteur2);
//    cube1.tracer_vecteur3(groupe_vecteurs, pen_vecteur3);

//    cube2.tracer_vecteur1(groupe_vecteurs, pen_vecteur1);
//    cube2.tracer_vecteur2(groupe_vecteurs, pen_vecteur2);
//    cube2.tracer_vecteur3(groupe_vecteurs, pen_vecteur3);


}



MainWindow::~MainWindow()
{

}



void MainWindow::effacer_cube()
{
    foreach( QGraphicsItem *item, scene->items( groupe_cube->boundingRect() ) )
    {
        if( item->group() == groupe_cube )  { delete item; }
    }
}


void MainWindow::effacer_vecteurs()
{
    foreach( QGraphicsItem *item, scene->items( groupe_vecteurs->boundingRect() ) )
    {
        if( item->group() == groupe_vecteurs )  { delete item; }
    }
}



void MainWindow::tracer_cadre()
{

    rectangle = new QGraphicsRectItem(0, 0, 900, 900);
    rectangle->setPen(pen_cadre);
    groupe_axes->addToGroup(rectangle);

}


void MainWindow::tracer_point(int x_aff, int y_aff, QPen pen_i)
{
    if (y_aff<550)
    {
        rectangle = new QGraphicsRectItem(x_aff, 300-y_aff, 1, 1);
        rectangle->setPen(pen_i);
        groupe_cube->addToGroup(rectangle);
    }
}


void MainWindow::tracer_point_2(int x_aff, int y_aff )
{
    if (y_aff<550)
    {
        rectangle = new QGraphicsRectItem(x_aff, 300-y_aff, 1, 1);
        rectangle->setPen(pen_trace2);
        groupe_cube->addToGroup(rectangle);
    }
}



void MainWindow::rotation_cubes(QString ordre)
{
    if(ordre == "abg")
    {
        cube1.RotX(alpha0); cube1.RotY(beta0); cube1.RotZ(gamma0);
        cube2.RotX(alpha0); cube2.RotY(beta0); cube2.RotZ(gamma0);
    }
    if(ordre == "agb")
    {
        cube1.RotX(alpha0); cube1.RotZ(gamma0); cube1.RotY(beta0);
        cube2.RotX(alpha0); cube2.RotZ(gamma0); cube2.RotY(beta0);
    }
    if(ordre == "bag")
    {
        cube1.RotY(beta0); cube1.RotX(alpha0); cube1.RotZ(gamma0);
        cube2.RotY(beta0); cube2.RotX(alpha0); cube2.RotZ(gamma0);
    }
    if(ordre == "bga")
    {
        cube1.RotY(beta0); cube1.RotZ(gamma0); cube1.RotX(alpha0);
        cube2.RotY(beta0); cube2.RotZ(gamma0); cube2.RotX(alpha0);
    }
    if(ordre == "gab")
    {
        cube1.RotZ(gamma0); cube1.RotX(alpha0); cube1.RotY(beta0);
        cube2.RotZ(gamma0); cube2.RotX(alpha0); cube2.RotY(beta0);
    }
    if(ordre == "gba")
    {
        cube1.RotZ(gamma0); cube1.RotY(beta0); cube1.RotX(alpha0);
        cube2.RotZ(gamma0); cube2.RotY(beta0); cube2.RotX(alpha0);
    }
}
;


void MainWindow::tracer(QString ordre)
{

    V1.setX(spinBox_1->value());
    V1.setY(spinBox_2->value());
    V1.setZ(spinBox_3->value());

    V2.setX(spinBox_7->value());
    V2.setY(spinBox_8->value());
    V2.setZ(spinBox_9->value());

    V3=V1*V2; // produit vectoriel

    QString  st1;
    st1.setNum(V3.getX());     lineEdit_1->setText(st1);
    st1.setNum(V3.getY());     lineEdit_2->setText(st1);
    st1.setNum(V3.getZ());     lineEdit_3->setText(st1);

    cube1.set_V1(V1);
    cube1.set_V2(V2);
    cube1.set_V3(V3);
    cube1.set_sommets();

    cube2.set_V1(V1);
    cube2.set_V2(V2);
    cube2.set_V3(V3);
    cube2.set_sommets();

    rotation_cubes(ordre);
    effacer_cube();
    cube1.tracer(groupe_cube, pen_ligne, 1);
    cube2.tracer(groupe_cube, pen_ligne, 1);

    effacer_vecteurs();
    cube1.tracer_vecteur1(groupe_vecteurs, pen_vecteur1);
    cube1.tracer_vecteur2(groupe_vecteurs, pen_vecteur2);
    cube1.tracer_vecteur3(groupe_vecteurs, pen_vecteur3);

    cube2.tracer_vecteur1(groupe_vecteurs, pen_vecteur1);
    cube2.tracer_vecteur2(groupe_vecteurs, pen_vecteur2);
    cube2.tracer_vecteur3(groupe_vecteurs, pen_vecteur3);
}



void MainWindow::on_spinBox_1_valueChanged(int arg1)
{
  if(init == 1) {tracer("abg"); }
}


void MainWindow::on_spinBox_2_valueChanged(int arg1)
{
   if(init == 1) {tracer("abg"); }
}


void MainWindow::on_spinBox_3_valueChanged(int arg1)
{
    if(init == 1) {tracer("abg");}
}


void MainWindow::on_spinBox_7_valueChanged(int arg1)
{
    if(init == 1) {tracer("abg"); }
}


void MainWindow::on_spinBox_8_valueChanged(int arg1)
{
    if(init == 1) {tracer("abg");}
}


void MainWindow::on_spinBox_9_valueChanged(int arg1)
{
    if(init == 1) {tracer("abg"); }
}



void MainWindow::on_horizontalSlider1_valueChanged(int value)
{
    QString  st1;
    st1.setNum(value);
    lineEdit_x->setText(st1);
    alpha0 = (double) value/180*M_PI;

    tracer("agb");
}


void MainWindow::on_horizontalSlider2_valueChanged(int value)
{
    QString  st1;
    st1.setNum(value);
    lineEdit_y->setText(st1);
    beta0 = (double) value/180*M_PI;

    tracer("bga");
}


void MainWindow::on_horizontalSlider3_valueChanged(int value)
{
    QString  st1;
    st1.setNum(value);
    lineEdit_z->setText(st1);
    gamma0 = (double) value/180*M_PI;

    tracer("gba");
}


void MainWindow::on_Btn_reset_clicked()
{
    Timer1->stop();

    horizontalSlider1->setValue(110);
    horizontalSlider2->setValue(0);
    horizontalSlider3->setValue(-26);

}



void MainWindow::Timer1_clic()
{
    int i;
    i=horizontalSlider1->value();
    i++;
    if (i>180) {i=-180;}
    horizontalSlider1->setValue(i);


    i=horizontalSlider2->value();
    i++;
    if (i>180) {i=-180;}
    horizontalSlider2->setValue(i);
}


void MainWindow::on_Btn_X_Y_clicked()
{
    Timer1->stop();
    horizontalSlider1->setValue(0);
    horizontalSlider2->setValue(0);
    horizontalSlider3->setValue(0);
}

void MainWindow::on_Btn_Y_Z_clicked()
{
   Timer1->stop();
   horizontalSlider1->setValue(-90);
   horizontalSlider2->setValue(0);
   horizontalSlider3->setValue(-90);
}

void MainWindow::on_Btn_X_Z_clicked()
{
    Timer1->stop();
    horizontalSlider1->setValue(-90);
    horizontalSlider2->setValue(0);
    horizontalSlider3->setValue(0);
}

void MainWindow::on_Btn_anim_clicked()
{
    if(Timer1->isActive()) {Timer1->stop();} else {Timer1->start(50);}

}


