#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "ui_mainwindow.h"
#include <QGraphicsView>
#include <QGraphicsTextItem>
#include <QGraphicsLineItem>
#include <QGraphicsItemGroup>
#include <QTimer>

#include "vecteur3d.h"
#include "cube.h"



class MainWindow : public QMainWindow, public Ui::MainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    
private slots:

    void effacer_cube();
    void tracer_cadre();
    void effacer_vecteurs();
    void tracer_point(int x_aff, int y_aff, QPen pen_i);
    void tracer_point_2(int x_aff, int y_aff);

    void rotation_cubes(QString ordre);

    void tracer(QString ordre);

    void on_spinBox_1_valueChanged(int arg1);
    void on_spinBox_2_valueChanged(int arg1);
    void on_spinBox_3_valueChanged(int arg1);

    void on_horizontalSlider1_valueChanged(int value);
    void on_horizontalSlider2_valueChanged(int value);
    void on_horizontalSlider3_valueChanged(int value);

    void on_Btn_reset_clicked();

    void on_spinBox_7_valueChanged(int arg1);
    void on_spinBox_8_valueChanged(int arg1);
    void on_spinBox_9_valueChanged(int arg1);

    void Timer1_clic();
    void on_Btn_X_Y_clicked();
    void on_Btn_Y_Z_clicked();
    void on_Btn_X_Z_clicked();
    void on_Btn_anim_clicked();


private:

    QGraphicsScene *scene;
    QGraphicsItemGroup *groupe_axes;
    QGraphicsItemGroup *groupe_cube;
    QGraphicsItemGroup *groupe_vecteurs;

    QGraphicsLineItem *axeX;
    QGraphicsLineItem *axeY;
    QGraphicsLineItem *axeZ;

    QGraphicsLineItem *ligne1;
    QGraphicsLineItem *ligne2;

    QGraphicsRectItem *rectangle;
    QGraphicsEllipseItem *ellipse1;

    QTimer *Timer1;

};

#endif // MAINWINDOW_H
